//===- TableGen'erated file -------------------------------------*- C++ -*-===//
//
// LLVMC Configuration Library
//
// Automatically generated file, do not edit!
//
//===----------------------------------------------------------------------===//

#include "llvm/CompilerDriver/BuiltinOptions.h"
#include "llvm/CompilerDriver/CompilationGraph.h"
#include "llvm/CompilerDriver/ForceLinkageMacros.h"
#include "llvm/CompilerDriver/Plugin.h"
#include "llvm/CompilerDriver/Tool.h"

#include "llvm/Support/CommandLine.h"
#include "llvm/Support/raw_ostream.h"

#include <algorithm>
#include <cstdlib>
#include <iterator>
#include <stdexcept>

using namespace llvm;
using namespace llvmc;

extern cl::opt<std::string> OutputFilename;

inline const char* checkCString(const char* s)
{ return s == NULL ? "" : s; }

cl::opt<bool> AutoGeneratedSwitch_dead_strip("dead_strip"
, cl::Hidden, cl::desc("Remove unreachable blocks of code"));

cl::list<std::string> AutoGeneratedList_MT("MT"
, cl::Hidden, cl::desc("Change the name of the rule emitted by dependency generation"));

cl::opt<bool> AutoGeneratedSwitch_dynamiclib("dynamiclib"
, cl::Hidden, cl::desc("Produce a dynamic library"));

cl::list<std::string> AutoGeneratedList_D("D"
, cl::Prefix, cl::desc("Define a macro"));

cl::opt<bool> AutoGeneratedSwitch_E("E"
, cl::desc("Stop after the preprocessing stage, do not run the compiler"));

cl::opt<bool> AutoGeneratedSwitch_mdynamic_dash_no_dash_pic("mdynamic-no-pic"
, cl::Hidden, cl::desc("Relocation model: dynamic-no-pic"));

cl::list<std::string> AutoGeneratedList_F("F"
, cl::Prefix, cl::desc("Add a directory to framework search path"));

cl::opt<bool> AutoGeneratedSwitch_pthread("pthread"
, cl::desc("Enable threads"));

cl::list<std::string> AutoGeneratedList_I("I"
, cl::Prefix, cl::desc("Add a directory to include path"));

cl::list<std::string> AutoGeneratedList_Wa_comma_("Wa,"
, cl::Prefix, cl::CommaSeparated, cl::desc("Pass options to assembler"));

cl::opt<std::string> AutoGeneratedParameter_march("march"
, cl::Hidden, cl::desc("A synonym for -mtune"));

cl::list<std::string> AutoGeneratedList_L("L"
, cl::Prefix, cl::desc("Add a directory to link path"));

cl::list<std::string> AutoGeneratedList_framework("framework"
, cl::desc("Specifies a framework to link against"));

cl::list<std::string> AutoGeneratedList_Wo_comma_("Wo,"
, cl::Prefix, cl::CommaSeparated, cl::desc("Pass options to opt"));

cl::opt<bool> AutoGeneratedSwitch_opt("opt"
, cl::desc("Enable opt"));

cl::opt<bool> AutoGeneratedSwitch_S("S"
, cl::desc("Stop after compilation, do not assemble"));

cl::opt<std::string> AutoGeneratedParameter_mcpu("mcpu"
, cl::Hidden, cl::desc("A deprecated synonym for -mtune"));

cl::opt<bool> AutoGeneratedSwitch_m64("m64"
, cl::Hidden, cl::desc("Generate code for a 64-bit environment"));

cl::list<std::string> AutoGeneratedList_iquote("iquote"
, cl::Hidden, cl::desc("Search dir only for files requested with #inlcude \"file\""));

cl::opt<std::string> AutoGeneratedParameter_compatibility_version("compatibility_version"
, cl::Hidden, cl::desc("Compatibility version number"));

cl::opt<std::string> AutoGeneratedParameter_current_version("current_version"
, cl::Hidden, cl::desc("Current version number"));

cl::opt<std::string> AutoGeneratedParameter_arch("arch"
, cl::Hidden, cl::desc("Compile for the specified target architecture"));

cl::opt<bool> AutoGeneratedSwitch_O0("O0"
, cl::ZeroOrMore, cl::desc("Turn off optimization"));

cl::opt<bool> AutoGeneratedSwitch_O1("O1"
, cl::ZeroOrMore, cl::desc("Optimization level 1"));

cl::opt<bool> AutoGeneratedSwitch_O2("O2"
, cl::ZeroOrMore, cl::desc("Optimization level 2"));

cl::opt<bool> AutoGeneratedSwitch_O3("O3"
, cl::ZeroOrMore, cl::desc("Optimization level 3"));

cl::opt<bool> AutoGeneratedSwitch_c("c"
, cl::desc("Compile and assemble, but do not link"));

cl::list<std::string> AutoGeneratedList_include("include"
, cl::desc("Include the named file prior to preprocessing"));

cl::opt<std::string> AutoGeneratedParameter_linker("linker"
, cl::desc("Choose linker (possible values: gcc, g++)"));

cl::opt<bool> AutoGeneratedSwitch_mfix_dash_and_dash_continue("mfix-and-continue"
, cl::Hidden, cl::desc("Needed by gdb to load .o files dynamically"));

cl::opt<bool> AutoGeneratedSwitch_prebind("prebind"
, cl::Hidden, cl::desc("Prebind all undefined symbols"));

cl::opt<bool> AutoGeneratedSwitch_fPIC("fPIC"
, cl::Hidden, cl::desc("Relocation model: PIC"));

cl::opt<std::string> AutoGeneratedParameter_mtune("mtune"
, cl::Hidden, cl::desc("Target a specific CPU type"));

cl::opt<bool> AutoGeneratedSwitch_single_module("single_module"
, cl::Hidden, cl::desc("Build the library so it contains only one module"));

cl::list<std::string> AutoGeneratedList_l("l"
, cl::Prefix, cl::desc("Search a library when linking"));

cl::list<std::string> AutoGeneratedList_Wllc_comma_("Wllc,"
, cl::Prefix, cl::CommaSeparated, cl::desc("Pass options to llc"));

cl::list<std::string> AutoGeneratedList_m("m"
, cl::Prefix, cl::Hidden, cl::desc("Enable or disable various extensions (-mmmx, -msse, etc.)"));

cl::list<std::string> AutoGeneratedList_Wl_comma_("Wl,"
, cl::Prefix, cl::desc("Pass options to linker"));

cl::opt<bool> AutoGeneratedSwitch_m32("m32"
, cl::Hidden, cl::desc("Generate code for a 32-bit environment"));

cl::opt<std::string> AutoGeneratedParameter_MF("MF"
, cl::Hidden, cl::desc("Specify a file to write dependencies to"));

cl::list<std::string> AutoGeneratedList_weak_framework("weak_framework"
, cl::Hidden, cl::desc("Specifies a framework to weakly link against"));

cl::list<std::string> AutoGeneratedList_Xassembler("Xassembler"
, cl::Hidden, cl::desc("Pass options to assembler"));

cl::opt<bool> AutoGeneratedSwitch_emit_dash_llvm("emit-llvm"
, cl::desc("Emit LLVM .ll files instead of native object files"));

cl::opt<std::string> AutoGeneratedParameter_install_name("install_name"
, cl::Hidden, cl::desc("File name the library will be installed in"));

cl::opt<bool> AutoGeneratedSwitch_fsyntax_dash_only("fsyntax-only"
, cl::desc("Stop after checking the input for syntax errors"));

cl::opt<std::string> AutoGeneratedParameter_filelist("filelist"
, cl::Hidden, cl::desc("Link the files listed in file"));

cl::list<std::string> AutoGeneratedList_Xlinker("Xlinker"
, cl::Hidden, cl::desc("Pass options to linker"));

cl::list<std::string> AutoGeneratedList_Xpreprocessor("Xpreprocessor"
, cl::Hidden, cl::desc("Pass options to preprocessor"));

cl::list<std::string> AutoGeneratedSinkOption(cl::Sink);

namespace hooks {
    std::string ConvertToMAttr(const std::vector<std::string>& Arg);
}

namespace {

void PreprocessOptionsLocal() {
    if (! (AutoGeneratedSwitch_O0 || AutoGeneratedSwitch_O1 || AutoGeneratedSwitch_O2 || AutoGeneratedSwitch_O3)) {
        AutoGeneratedSwitch_O2 = true;
    }
    if ((AutoGeneratedSwitch_O3)
         && (AutoGeneratedSwitch_O0 || AutoGeneratedSwitch_O1 || AutoGeneratedSwitch_O2)) {
        AutoGeneratedSwitch_O0 = false;
        AutoGeneratedSwitch_O1 = false;
        AutoGeneratedSwitch_O2 = false;
    }
    if ((AutoGeneratedSwitch_O2)
         && (AutoGeneratedSwitch_O0 || AutoGeneratedSwitch_O1)) {
        AutoGeneratedSwitch_O0 = false;
        AutoGeneratedSwitch_O1 = false;
    }
    if (AutoGeneratedSwitch_O1 && AutoGeneratedSwitch_O0) {
        AutoGeneratedSwitch_O0 = false;
    }
}

void PopulateLanguageMapLocal(LanguageMap& langMap) {
    langMap["cc"] = "c++";
    langMap["cp"] = "c++";
    langMap["cxx"] = "c++";
    langMap["cpp"] = "c++";
    langMap["CPP"] = "c++";
    langMap["c++"] = "c++";
    langMap["C"] = "c++";
    langMap["hpp"] = "c++-header";
    langMap["c"] = "c";
    langMap["h"] = "c-header";
    langMap["i"] = "c-cpp-output";
    langMap["mi"] = "objective-c-cpp-output";
    langMap["mm"] = "objective-c++";
    langMap["hmm"] = "objective-c++-header";
    langMap["m"] = "objective-c";
    langMap["hm"] = "objective-c-header";
    langMap["s"] = "assembler";
    langMap["S"] = "assembler-with-cpp";
    langMap["ll"] = "llvm-assembler";
    langMap["bc"] = "llvm-bitcode";
    langMap["o"] = "object-code";
    langMap["*empty*"] = "object-code";
    langMap["out"] = "executable";
}

class llc : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llc";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "assembler";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llc is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "s";

        cmd = "llc";
        vec.push_back(std::make_pair(0, "-f"));

        if (AutoGeneratedSwitch_S) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(65536, "-relocation-model=pic"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(65536, "-relocation-model=dynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mcpu=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mcpu=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedList_m.getPosition(0), hooks::ConvertToMAttr(AutoGeneratedList_m)));
        }
        if (!AutoGeneratedList_Wllc_comma_.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Wllc_comma_.begin(), 
                 E = AutoGeneratedList_Wllc_comma_.end(); B != E; ++B)
            {
                unsigned pos = AutoGeneratedList_Wllc_comma_.getPosition(B - AutoGeneratedList_Wllc_comma_.begin());
                vec.push_back(std::make_pair(pos, *B));
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llc::InputLanguages_[] = {"llvm-assembler", "llvm-bitcode", 0};

class llvm_as : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_as";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_as is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "bc";

        cmd = "llvm-as";

        if (AutoGeneratedSwitch_emit_dash_llvm) {
            stop_compilation = true;
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_as::InputLanguages_[] = {"llvm-assembler", 0};

class llvm_gcc_assembler : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_assembler";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "object-code";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_assembler is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "o";

        cmd = "llvm-gcc";
        vec.push_back(std::make_pair(0, "-c"));
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "assembler"));

        if (AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedList_Xassembler.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xassembler.begin(),
            E = AutoGeneratedList_Xassembler.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xassembler.getPosition(B - AutoGeneratedList_Xassembler.begin());
                vec.push_back(std::make_pair(pos, "-Xassembler"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Wa_comma_.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Wa_comma_.begin(),
            E = AutoGeneratedList_Wa_comma_.end(); B != E;) {
                unsigned pos = AutoGeneratedList_Wa_comma_.getPosition(B - AutoGeneratedList_Wa_comma_.begin());
                vec.push_back(std::make_pair(pos, "-Wa," + *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_assembler::InputLanguages_[] = {"assembler", 0};

class llvm_gcc_c : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_c";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_c is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "bc";

        cmd = "llvm-gcc";
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "c"));

        if ((!OutputFilename.empty())
             && (InputFilenames.size() > 1)
             && ((AutoGeneratedSwitch_S)
             || (AutoGeneratedSwitch_c))) {
            throw std::runtime_error("cannot specify -o with -c or -S with multiple files");
        }
        if (AutoGeneratedSwitch_E) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_E.getPosition(), "-E"));
            stop_compilation = true;
            output_suffix = "i";
        }
        if ((AutoGeneratedSwitch_E)
             && (OutputFilename.empty())) {
            no_out_file = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_S) {
            output_suffix = "ll";
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_fsyntax_dash_only) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fsyntax_dash_only.getPosition(), "-fsyntax-only"));
            no_out_file = true;
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_S.getPosition(), "-S"));
            vec.push_back(std::make_pair(AutoGeneratedSwitch_emit_dash_llvm.getPosition(), "-emit-llvm"));
        }
        if (! ((AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm)
             || (AutoGeneratedSwitch_fsyntax_dash_only))) {
            vec.push_back(std::make_pair(65536, "-c"));
            vec.push_back(std::make_pair(65536, "-emit-llvm"));
        }
        if (!AutoGeneratedList_Xpreprocessor.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xpreprocessor.begin(),
            E = AutoGeneratedList_Xpreprocessor.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xpreprocessor.getPosition(B - AutoGeneratedList_Xpreprocessor.begin());
                vec.push_back(std::make_pair(pos, "-Xpreprocessor"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_include.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_include.begin(),
            E = AutoGeneratedList_include.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_include.getPosition(B - AutoGeneratedList_include.begin());
                vec.push_back(std::make_pair(pos, "-include"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_iquote.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_iquote.begin(),
            E = AutoGeneratedList_iquote.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_iquote.getPosition(B - AutoGeneratedList_iquote.begin());
                vec.push_back(std::make_pair(pos, "-iquote"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!(SaveTemps == SaveTempsEnum::Unset)) {
            vec.push_back(std::make_pair(65536, "-save-temps"));
        }
        if (!AutoGeneratedList_I.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_I.begin(),
            E = AutoGeneratedList_I.end(); B != E;) {
                unsigned pos = AutoGeneratedList_I.getPosition(B - AutoGeneratedList_I.begin());
                vec.push_back(std::make_pair(pos, "-I" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_D.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_D.begin(),
            E = AutoGeneratedList_D.end(); B != E;) {
                unsigned pos = AutoGeneratedList_D.getPosition(B - AutoGeneratedList_D.begin());
                vec.push_back(std::make_pair(pos, "-D" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_march.getPosition(), "-march=" + AutoGeneratedParameter_march));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mtune=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_m.begin(),
            E = AutoGeneratedList_m.end(); B != E;) {
                unsigned pos = AutoGeneratedList_m.getPosition(B - AutoGeneratedList_m.begin());
                vec.push_back(std::make_pair(pos, "-m" + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_mfix_dash_and_dash_continue) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mfix_dash_and_dash_continue.getPosition(), "-mfix-and-continue"));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fPIC.getPosition(), "-fPIC"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mdynamic_dash_no_dash_pic.getPosition(), "-mdynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_MF.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), "-MF"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), AutoGeneratedParameter_MF));
        }
        if (!AutoGeneratedList_MT.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_MT.begin(),
            E = AutoGeneratedList_MT.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_MT.getPosition(B - AutoGeneratedList_MT.begin());
                vec.push_back(std::make_pair(pos, "-MT"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        if (!AutoGeneratedSinkOption.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedSinkOption.begin(), E = AutoGeneratedSinkOption.end(); B != E; ++B)
                vec.push_back(std::make_pair(AutoGeneratedSinkOption.getPosition(B - AutoGeneratedSinkOption.begin()), *B));
        }
        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_c::InputLanguages_[] = {"c", 0};

class llvm_gcc_c_pch : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_c_pch";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_c_pch is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "gch";

        cmd = "llvm-gcc";
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "c-header"));

        if ((!OutputFilename.empty())
             && (InputFilenames.size() > 1)
             && ((AutoGeneratedSwitch_S)
             || (AutoGeneratedSwitch_c))) {
            throw std::runtime_error("cannot specify -o with -c or -S with multiple files");
        }
        if (AutoGeneratedSwitch_E) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_E.getPosition(), "-E"));
            stop_compilation = true;
            output_suffix = "i";
        }
        if ((AutoGeneratedSwitch_E)
             && (OutputFilename.empty())) {
            no_out_file = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_S) {
            output_suffix = "ll";
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_fsyntax_dash_only) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fsyntax_dash_only.getPosition(), "-fsyntax-only"));
            no_out_file = true;
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_S.getPosition(), "-S"));
            vec.push_back(std::make_pair(AutoGeneratedSwitch_emit_dash_llvm.getPosition(), "-emit-llvm"));
        }
        if (! ((AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm)
             || (AutoGeneratedSwitch_fsyntax_dash_only))) {
            vec.push_back(std::make_pair(65536, "-c"));
            vec.push_back(std::make_pair(65536, "-emit-llvm"));
        }
        if (!AutoGeneratedList_Xpreprocessor.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xpreprocessor.begin(),
            E = AutoGeneratedList_Xpreprocessor.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xpreprocessor.getPosition(B - AutoGeneratedList_Xpreprocessor.begin());
                vec.push_back(std::make_pair(pos, "-Xpreprocessor"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_include.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_include.begin(),
            E = AutoGeneratedList_include.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_include.getPosition(B - AutoGeneratedList_include.begin());
                vec.push_back(std::make_pair(pos, "-include"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_iquote.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_iquote.begin(),
            E = AutoGeneratedList_iquote.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_iquote.getPosition(B - AutoGeneratedList_iquote.begin());
                vec.push_back(std::make_pair(pos, "-iquote"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!(SaveTemps == SaveTempsEnum::Unset)) {
            vec.push_back(std::make_pair(65536, "-save-temps"));
        }
        if (!AutoGeneratedList_I.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_I.begin(),
            E = AutoGeneratedList_I.end(); B != E;) {
                unsigned pos = AutoGeneratedList_I.getPosition(B - AutoGeneratedList_I.begin());
                vec.push_back(std::make_pair(pos, "-I" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_D.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_D.begin(),
            E = AutoGeneratedList_D.end(); B != E;) {
                unsigned pos = AutoGeneratedList_D.getPosition(B - AutoGeneratedList_D.begin());
                vec.push_back(std::make_pair(pos, "-D" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_march.getPosition(), "-march=" + AutoGeneratedParameter_march));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mtune=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_m.begin(),
            E = AutoGeneratedList_m.end(); B != E;) {
                unsigned pos = AutoGeneratedList_m.getPosition(B - AutoGeneratedList_m.begin());
                vec.push_back(std::make_pair(pos, "-m" + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_mfix_dash_and_dash_continue) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mfix_dash_and_dash_continue.getPosition(), "-mfix-and-continue"));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fPIC.getPosition(), "-fPIC"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mdynamic_dash_no_dash_pic.getPosition(), "-mdynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_MF.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), "-MF"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), AutoGeneratedParameter_MF));
        }
        if (!AutoGeneratedList_MT.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_MT.begin(),
            E = AutoGeneratedList_MT.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_MT.getPosition(B - AutoGeneratedList_MT.begin());
                vec.push_back(std::make_pair(pos, "-MT"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        if (!AutoGeneratedSinkOption.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedSinkOption.begin(), E = AutoGeneratedSinkOption.end(); B != E; ++B)
                vec.push_back(std::make_pair(AutoGeneratedSinkOption.getPosition(B - AutoGeneratedSinkOption.begin()), *B));
        }
        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_c_pch::InputLanguages_[] = {"c-header", 0};

class llvm_gcc_cpp : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_cpp";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_cpp is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "bc";

        cmd = "llvm-g++";
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "c++"));

        if ((!OutputFilename.empty())
             && (InputFilenames.size() > 1)
             && ((AutoGeneratedSwitch_S)
             || (AutoGeneratedSwitch_c))) {
            throw std::runtime_error("cannot specify -o with -c or -S with multiple files");
        }
        if (AutoGeneratedSwitch_E) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_E.getPosition(), "-E"));
            stop_compilation = true;
            output_suffix = "i";
        }
        if ((AutoGeneratedSwitch_E)
             && (OutputFilename.empty())) {
            no_out_file = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_S) {
            output_suffix = "ll";
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_fsyntax_dash_only) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fsyntax_dash_only.getPosition(), "-fsyntax-only"));
            no_out_file = true;
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_S.getPosition(), "-S"));
            vec.push_back(std::make_pair(AutoGeneratedSwitch_emit_dash_llvm.getPosition(), "-emit-llvm"));
        }
        if (! ((AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm)
             || (AutoGeneratedSwitch_fsyntax_dash_only))) {
            vec.push_back(std::make_pair(65536, "-c"));
            vec.push_back(std::make_pair(65536, "-emit-llvm"));
        }
        if (!AutoGeneratedList_Xpreprocessor.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xpreprocessor.begin(),
            E = AutoGeneratedList_Xpreprocessor.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xpreprocessor.getPosition(B - AutoGeneratedList_Xpreprocessor.begin());
                vec.push_back(std::make_pair(pos, "-Xpreprocessor"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_include.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_include.begin(),
            E = AutoGeneratedList_include.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_include.getPosition(B - AutoGeneratedList_include.begin());
                vec.push_back(std::make_pair(pos, "-include"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_iquote.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_iquote.begin(),
            E = AutoGeneratedList_iquote.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_iquote.getPosition(B - AutoGeneratedList_iquote.begin());
                vec.push_back(std::make_pair(pos, "-iquote"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!(SaveTemps == SaveTempsEnum::Unset)) {
            vec.push_back(std::make_pair(65536, "-save-temps"));
        }
        if (!AutoGeneratedList_I.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_I.begin(),
            E = AutoGeneratedList_I.end(); B != E;) {
                unsigned pos = AutoGeneratedList_I.getPosition(B - AutoGeneratedList_I.begin());
                vec.push_back(std::make_pair(pos, "-I" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_D.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_D.begin(),
            E = AutoGeneratedList_D.end(); B != E;) {
                unsigned pos = AutoGeneratedList_D.getPosition(B - AutoGeneratedList_D.begin());
                vec.push_back(std::make_pair(pos, "-D" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_march.getPosition(), "-march=" + AutoGeneratedParameter_march));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mtune=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_m.begin(),
            E = AutoGeneratedList_m.end(); B != E;) {
                unsigned pos = AutoGeneratedList_m.getPosition(B - AutoGeneratedList_m.begin());
                vec.push_back(std::make_pair(pos, "-m" + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_mfix_dash_and_dash_continue) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mfix_dash_and_dash_continue.getPosition(), "-mfix-and-continue"));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fPIC.getPosition(), "-fPIC"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mdynamic_dash_no_dash_pic.getPosition(), "-mdynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_MF.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), "-MF"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), AutoGeneratedParameter_MF));
        }
        if (!AutoGeneratedList_MT.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_MT.begin(),
            E = AutoGeneratedList_MT.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_MT.getPosition(B - AutoGeneratedList_MT.begin());
                vec.push_back(std::make_pair(pos, "-MT"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        if (!AutoGeneratedSinkOption.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedSinkOption.begin(), E = AutoGeneratedSinkOption.end(); B != E; ++B)
                vec.push_back(std::make_pair(AutoGeneratedSinkOption.getPosition(B - AutoGeneratedSinkOption.begin()), *B));
        }
        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_cpp::InputLanguages_[] = {"c++", 0};

class llvm_gcc_cpp_linker : public JoinTool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_cpp_linker";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "executable";
    }

    bool IsJoin() const {
        return true;
    }

    bool WorksOnEmpty() const {
        if (!AutoGeneratedParameter_filelist.empty()) {
            return true;
        }
        else {
            return false;
        }
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "out";

        cmd = "llvm-g++";

        if (AutoGeneratedSwitch_pthread) {
            vec.push_back(std::make_pair(65536, "-lpthread"));
        }
        if (!AutoGeneratedList_L.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_L.begin(),
            E = AutoGeneratedList_L.end(); B != E;) {
                unsigned pos = AutoGeneratedList_L.getPosition(B - AutoGeneratedList_L.begin());
                vec.push_back(std::make_pair(pos, "-L" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedList_framework.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_framework.begin(),
            E = AutoGeneratedList_framework.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_framework.getPosition(B - AutoGeneratedList_framework.begin());
                vec.push_back(std::make_pair(pos, "-framework"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_weak_framework.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_weak_framework.begin(),
            E = AutoGeneratedList_weak_framework.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_weak_framework.getPosition(B - AutoGeneratedList_weak_framework.begin());
                vec.push_back(std::make_pair(pos, "-weak_framework"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_filelist.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_filelist.getPosition(), "-filelist"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_filelist.getPosition(), AutoGeneratedParameter_filelist));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (!AutoGeneratedList_l.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_l.begin(),
            E = AutoGeneratedList_l.end(); B != E;) {
                unsigned pos = AutoGeneratedList_l.getPosition(B - AutoGeneratedList_l.begin());
                vec.push_back(std::make_pair(pos, "-l" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Xlinker.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xlinker.begin(),
            E = AutoGeneratedList_Xlinker.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xlinker.getPosition(B - AutoGeneratedList_Xlinker.begin());
                vec.push_back(std::make_pair(pos, "-Xlinker"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Wl_comma_.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Wl_comma_.begin(),
            E = AutoGeneratedList_Wl_comma_.end(); B != E;) {
                unsigned pos = AutoGeneratedList_Wl_comma_.getPosition(B - AutoGeneratedList_Wl_comma_.begin());
                vec.push_back(std::make_pair(pos, "-Wl," + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_dynamiclib) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_dynamiclib.getPosition(), "-dynamiclib"));
        }
        if (AutoGeneratedSwitch_prebind) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_prebind.getPosition(), "-prebind"));
        }
        if (AutoGeneratedSwitch_dead_strip) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_dead_strip.getPosition(), "-dead_strip"));
        }
        if (AutoGeneratedSwitch_single_module) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_single_module.getPosition(), "-single_module"));
        }
        if (!AutoGeneratedParameter_compatibility_version.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_compatibility_version.getPosition(), "-compatibility_version"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_compatibility_version.getPosition(), AutoGeneratedParameter_compatibility_version));
        }
        if (!AutoGeneratedParameter_current_version.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_current_version.getPosition(), "-current_version"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_current_version.getPosition(), AutoGeneratedParameter_current_version));
        }
        if (!AutoGeneratedParameter_install_name.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_install_name.getPosition(), "-install_name"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_install_name.getPosition(), AutoGeneratedParameter_install_name));
        }

        for (PathVector::const_iterator B = inFiles.begin(),
            E = inFiles.end(); B != E; ++B)
        {
            vec.push_back(std::make_pair(InputFilenames.getPosition(B - inFiles.begin()), B->str()));
        }
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(sys::Path(),
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "out";

        cmd = "llvm-g++";

        if (AutoGeneratedSwitch_pthread) {
            vec.push_back(std::make_pair(65536, "-lpthread"));
        }
        if (!AutoGeneratedList_L.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_L.begin(),
            E = AutoGeneratedList_L.end(); B != E;) {
                unsigned pos = AutoGeneratedList_L.getPosition(B - AutoGeneratedList_L.begin());
                vec.push_back(std::make_pair(pos, "-L" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedList_framework.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_framework.begin(),
            E = AutoGeneratedList_framework.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_framework.getPosition(B - AutoGeneratedList_framework.begin());
                vec.push_back(std::make_pair(pos, "-framework"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_weak_framework.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_weak_framework.begin(),
            E = AutoGeneratedList_weak_framework.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_weak_framework.getPosition(B - AutoGeneratedList_weak_framework.begin());
                vec.push_back(std::make_pair(pos, "-weak_framework"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_filelist.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_filelist.getPosition(), "-filelist"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_filelist.getPosition(), AutoGeneratedParameter_filelist));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (!AutoGeneratedList_l.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_l.begin(),
            E = AutoGeneratedList_l.end(); B != E;) {
                unsigned pos = AutoGeneratedList_l.getPosition(B - AutoGeneratedList_l.begin());
                vec.push_back(std::make_pair(pos, "-l" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Xlinker.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xlinker.begin(),
            E = AutoGeneratedList_Xlinker.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xlinker.getPosition(B - AutoGeneratedList_Xlinker.begin());
                vec.push_back(std::make_pair(pos, "-Xlinker"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Wl_comma_.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Wl_comma_.begin(),
            E = AutoGeneratedList_Wl_comma_.end(); B != E;) {
                unsigned pos = AutoGeneratedList_Wl_comma_.getPosition(B - AutoGeneratedList_Wl_comma_.begin());
                vec.push_back(std::make_pair(pos, "-Wl," + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_dynamiclib) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_dynamiclib.getPosition(), "-dynamiclib"));
        }
        if (AutoGeneratedSwitch_prebind) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_prebind.getPosition(), "-prebind"));
        }
        if (AutoGeneratedSwitch_dead_strip) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_dead_strip.getPosition(), "-dead_strip"));
        }
        if (AutoGeneratedSwitch_single_module) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_single_module.getPosition(), "-single_module"));
        }
        if (!AutoGeneratedParameter_compatibility_version.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_compatibility_version.getPosition(), "-compatibility_version"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_compatibility_version.getPosition(), AutoGeneratedParameter_compatibility_version));
        }
        if (!AutoGeneratedParameter_current_version.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_current_version.getPosition(), "-current_version"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_current_version.getPosition(), AutoGeneratedParameter_current_version));
        }
        if (!AutoGeneratedParameter_install_name.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_install_name.getPosition(), "-install_name"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_install_name.getPosition(), AutoGeneratedParameter_install_name));
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_cpp_linker::InputLanguages_[] = {"object-code", 0};

class llvm_gcc_cpp_pch : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_cpp_pch";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_cpp_pch is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "gch";

        cmd = "llvm-g++";
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "c++-header"));

        if ((!OutputFilename.empty())
             && (InputFilenames.size() > 1)
             && ((AutoGeneratedSwitch_S)
             || (AutoGeneratedSwitch_c))) {
            throw std::runtime_error("cannot specify -o with -c or -S with multiple files");
        }
        if (AutoGeneratedSwitch_E) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_E.getPosition(), "-E"));
            stop_compilation = true;
            output_suffix = "i";
        }
        if ((AutoGeneratedSwitch_E)
             && (OutputFilename.empty())) {
            no_out_file = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_S) {
            output_suffix = "ll";
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_fsyntax_dash_only) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fsyntax_dash_only.getPosition(), "-fsyntax-only"));
            no_out_file = true;
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_S.getPosition(), "-S"));
            vec.push_back(std::make_pair(AutoGeneratedSwitch_emit_dash_llvm.getPosition(), "-emit-llvm"));
        }
        if (! ((AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm)
             || (AutoGeneratedSwitch_fsyntax_dash_only))) {
            vec.push_back(std::make_pair(65536, "-c"));
            vec.push_back(std::make_pair(65536, "-emit-llvm"));
        }
        if (!AutoGeneratedList_Xpreprocessor.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xpreprocessor.begin(),
            E = AutoGeneratedList_Xpreprocessor.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xpreprocessor.getPosition(B - AutoGeneratedList_Xpreprocessor.begin());
                vec.push_back(std::make_pair(pos, "-Xpreprocessor"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_include.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_include.begin(),
            E = AutoGeneratedList_include.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_include.getPosition(B - AutoGeneratedList_include.begin());
                vec.push_back(std::make_pair(pos, "-include"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_iquote.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_iquote.begin(),
            E = AutoGeneratedList_iquote.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_iquote.getPosition(B - AutoGeneratedList_iquote.begin());
                vec.push_back(std::make_pair(pos, "-iquote"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!(SaveTemps == SaveTempsEnum::Unset)) {
            vec.push_back(std::make_pair(65536, "-save-temps"));
        }
        if (!AutoGeneratedList_I.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_I.begin(),
            E = AutoGeneratedList_I.end(); B != E;) {
                unsigned pos = AutoGeneratedList_I.getPosition(B - AutoGeneratedList_I.begin());
                vec.push_back(std::make_pair(pos, "-I" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_D.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_D.begin(),
            E = AutoGeneratedList_D.end(); B != E;) {
                unsigned pos = AutoGeneratedList_D.getPosition(B - AutoGeneratedList_D.begin());
                vec.push_back(std::make_pair(pos, "-D" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_march.getPosition(), "-march=" + AutoGeneratedParameter_march));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mtune=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_m.begin(),
            E = AutoGeneratedList_m.end(); B != E;) {
                unsigned pos = AutoGeneratedList_m.getPosition(B - AutoGeneratedList_m.begin());
                vec.push_back(std::make_pair(pos, "-m" + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_mfix_dash_and_dash_continue) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mfix_dash_and_dash_continue.getPosition(), "-mfix-and-continue"));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fPIC.getPosition(), "-fPIC"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mdynamic_dash_no_dash_pic.getPosition(), "-mdynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_MF.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), "-MF"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), AutoGeneratedParameter_MF));
        }
        if (!AutoGeneratedList_MT.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_MT.begin(),
            E = AutoGeneratedList_MT.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_MT.getPosition(B - AutoGeneratedList_MT.begin());
                vec.push_back(std::make_pair(pos, "-MT"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        if (!AutoGeneratedSinkOption.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedSinkOption.begin(), E = AutoGeneratedSinkOption.end(); B != E; ++B)
                vec.push_back(std::make_pair(AutoGeneratedSinkOption.getPosition(B - AutoGeneratedSinkOption.begin()), *B));
        }
        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_cpp_pch::InputLanguages_[] = {"c++-header", 0};

class llvm_gcc_linker : public JoinTool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_linker";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "executable";
    }

    bool IsJoin() const {
        return true;
    }

    bool WorksOnEmpty() const {
        if (!AutoGeneratedParameter_filelist.empty()) {
            return true;
        }
        else {
            return false;
        }
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "out";

        cmd = "llvm-gcc";

        if (AutoGeneratedSwitch_pthread) {
            vec.push_back(std::make_pair(65536, "-lpthread"));
        }
        if (!AutoGeneratedList_L.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_L.begin(),
            E = AutoGeneratedList_L.end(); B != E;) {
                unsigned pos = AutoGeneratedList_L.getPosition(B - AutoGeneratedList_L.begin());
                vec.push_back(std::make_pair(pos, "-L" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedList_framework.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_framework.begin(),
            E = AutoGeneratedList_framework.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_framework.getPosition(B - AutoGeneratedList_framework.begin());
                vec.push_back(std::make_pair(pos, "-framework"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_weak_framework.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_weak_framework.begin(),
            E = AutoGeneratedList_weak_framework.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_weak_framework.getPosition(B - AutoGeneratedList_weak_framework.begin());
                vec.push_back(std::make_pair(pos, "-weak_framework"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_filelist.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_filelist.getPosition(), "-filelist"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_filelist.getPosition(), AutoGeneratedParameter_filelist));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (!AutoGeneratedList_l.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_l.begin(),
            E = AutoGeneratedList_l.end(); B != E;) {
                unsigned pos = AutoGeneratedList_l.getPosition(B - AutoGeneratedList_l.begin());
                vec.push_back(std::make_pair(pos, "-l" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Xlinker.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xlinker.begin(),
            E = AutoGeneratedList_Xlinker.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xlinker.getPosition(B - AutoGeneratedList_Xlinker.begin());
                vec.push_back(std::make_pair(pos, "-Xlinker"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Wl_comma_.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Wl_comma_.begin(),
            E = AutoGeneratedList_Wl_comma_.end(); B != E;) {
                unsigned pos = AutoGeneratedList_Wl_comma_.getPosition(B - AutoGeneratedList_Wl_comma_.begin());
                vec.push_back(std::make_pair(pos, "-Wl," + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_dynamiclib) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_dynamiclib.getPosition(), "-dynamiclib"));
        }
        if (AutoGeneratedSwitch_prebind) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_prebind.getPosition(), "-prebind"));
        }
        if (AutoGeneratedSwitch_dead_strip) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_dead_strip.getPosition(), "-dead_strip"));
        }
        if (AutoGeneratedSwitch_single_module) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_single_module.getPosition(), "-single_module"));
        }
        if (!AutoGeneratedParameter_compatibility_version.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_compatibility_version.getPosition(), "-compatibility_version"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_compatibility_version.getPosition(), AutoGeneratedParameter_compatibility_version));
        }
        if (!AutoGeneratedParameter_current_version.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_current_version.getPosition(), "-current_version"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_current_version.getPosition(), AutoGeneratedParameter_current_version));
        }
        if (!AutoGeneratedParameter_install_name.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_install_name.getPosition(), "-install_name"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_install_name.getPosition(), AutoGeneratedParameter_install_name));
        }

        for (PathVector::const_iterator B = inFiles.begin(),
            E = inFiles.end(); B != E; ++B)
        {
            vec.push_back(std::make_pair(InputFilenames.getPosition(B - inFiles.begin()), B->str()));
        }
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(sys::Path(),
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "out";

        cmd = "llvm-gcc";

        if (AutoGeneratedSwitch_pthread) {
            vec.push_back(std::make_pair(65536, "-lpthread"));
        }
        if (!AutoGeneratedList_L.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_L.begin(),
            E = AutoGeneratedList_L.end(); B != E;) {
                unsigned pos = AutoGeneratedList_L.getPosition(B - AutoGeneratedList_L.begin());
                vec.push_back(std::make_pair(pos, "-L" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedList_framework.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_framework.begin(),
            E = AutoGeneratedList_framework.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_framework.getPosition(B - AutoGeneratedList_framework.begin());
                vec.push_back(std::make_pair(pos, "-framework"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_weak_framework.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_weak_framework.begin(),
            E = AutoGeneratedList_weak_framework.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_weak_framework.getPosition(B - AutoGeneratedList_weak_framework.begin());
                vec.push_back(std::make_pair(pos, "-weak_framework"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_filelist.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_filelist.getPosition(), "-filelist"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_filelist.getPosition(), AutoGeneratedParameter_filelist));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (!AutoGeneratedList_l.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_l.begin(),
            E = AutoGeneratedList_l.end(); B != E;) {
                unsigned pos = AutoGeneratedList_l.getPosition(B - AutoGeneratedList_l.begin());
                vec.push_back(std::make_pair(pos, "-l" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Xlinker.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xlinker.begin(),
            E = AutoGeneratedList_Xlinker.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xlinker.getPosition(B - AutoGeneratedList_Xlinker.begin());
                vec.push_back(std::make_pair(pos, "-Xlinker"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_Wl_comma_.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Wl_comma_.begin(),
            E = AutoGeneratedList_Wl_comma_.end(); B != E;) {
                unsigned pos = AutoGeneratedList_Wl_comma_.getPosition(B - AutoGeneratedList_Wl_comma_.begin());
                vec.push_back(std::make_pair(pos, "-Wl," + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_dynamiclib) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_dynamiclib.getPosition(), "-dynamiclib"));
        }
        if (AutoGeneratedSwitch_prebind) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_prebind.getPosition(), "-prebind"));
        }
        if (AutoGeneratedSwitch_dead_strip) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_dead_strip.getPosition(), "-dead_strip"));
        }
        if (AutoGeneratedSwitch_single_module) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_single_module.getPosition(), "-single_module"));
        }
        if (!AutoGeneratedParameter_compatibility_version.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_compatibility_version.getPosition(), "-compatibility_version"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_compatibility_version.getPosition(), AutoGeneratedParameter_compatibility_version));
        }
        if (!AutoGeneratedParameter_current_version.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_current_version.getPosition(), "-current_version"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_current_version.getPosition(), AutoGeneratedParameter_current_version));
        }
        if (!AutoGeneratedParameter_install_name.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_install_name.getPosition(), "-install_name"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_install_name.getPosition(), AutoGeneratedParameter_install_name));
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_linker::InputLanguages_[] = {"object-code", 0};

class llvm_gcc_m : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_m";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_m is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "bc";

        cmd = "llvm-gcc";
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "objective-c"));

        if ((!OutputFilename.empty())
             && (InputFilenames.size() > 1)
             && ((AutoGeneratedSwitch_S)
             || (AutoGeneratedSwitch_c))) {
            throw std::runtime_error("cannot specify -o with -c or -S with multiple files");
        }
        if (AutoGeneratedSwitch_E) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_E.getPosition(), "-E"));
            stop_compilation = true;
            output_suffix = "mi";
        }
        if ((AutoGeneratedSwitch_E)
             && (OutputFilename.empty())) {
            no_out_file = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_S) {
            output_suffix = "ll";
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_fsyntax_dash_only) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fsyntax_dash_only.getPosition(), "-fsyntax-only"));
            no_out_file = true;
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_S.getPosition(), "-S"));
            vec.push_back(std::make_pair(AutoGeneratedSwitch_emit_dash_llvm.getPosition(), "-emit-llvm"));
        }
        if (! ((AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm)
             || (AutoGeneratedSwitch_fsyntax_dash_only))) {
            vec.push_back(std::make_pair(65536, "-c"));
            vec.push_back(std::make_pair(65536, "-emit-llvm"));
        }
        if (!AutoGeneratedList_Xpreprocessor.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xpreprocessor.begin(),
            E = AutoGeneratedList_Xpreprocessor.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xpreprocessor.getPosition(B - AutoGeneratedList_Xpreprocessor.begin());
                vec.push_back(std::make_pair(pos, "-Xpreprocessor"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_include.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_include.begin(),
            E = AutoGeneratedList_include.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_include.getPosition(B - AutoGeneratedList_include.begin());
                vec.push_back(std::make_pair(pos, "-include"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_iquote.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_iquote.begin(),
            E = AutoGeneratedList_iquote.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_iquote.getPosition(B - AutoGeneratedList_iquote.begin());
                vec.push_back(std::make_pair(pos, "-iquote"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!(SaveTemps == SaveTempsEnum::Unset)) {
            vec.push_back(std::make_pair(65536, "-save-temps"));
        }
        if (!AutoGeneratedList_I.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_I.begin(),
            E = AutoGeneratedList_I.end(); B != E;) {
                unsigned pos = AutoGeneratedList_I.getPosition(B - AutoGeneratedList_I.begin());
                vec.push_back(std::make_pair(pos, "-I" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_D.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_D.begin(),
            E = AutoGeneratedList_D.end(); B != E;) {
                unsigned pos = AutoGeneratedList_D.getPosition(B - AutoGeneratedList_D.begin());
                vec.push_back(std::make_pair(pos, "-D" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_march.getPosition(), "-march=" + AutoGeneratedParameter_march));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mtune=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_m.begin(),
            E = AutoGeneratedList_m.end(); B != E;) {
                unsigned pos = AutoGeneratedList_m.getPosition(B - AutoGeneratedList_m.begin());
                vec.push_back(std::make_pair(pos, "-m" + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_mfix_dash_and_dash_continue) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mfix_dash_and_dash_continue.getPosition(), "-mfix-and-continue"));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fPIC.getPosition(), "-fPIC"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mdynamic_dash_no_dash_pic.getPosition(), "-mdynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_MF.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), "-MF"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), AutoGeneratedParameter_MF));
        }
        if (!AutoGeneratedList_MT.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_MT.begin(),
            E = AutoGeneratedList_MT.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_MT.getPosition(B - AutoGeneratedList_MT.begin());
                vec.push_back(std::make_pair(pos, "-MT"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        if (!AutoGeneratedSinkOption.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedSinkOption.begin(), E = AutoGeneratedSinkOption.end(); B != E; ++B)
                vec.push_back(std::make_pair(AutoGeneratedSinkOption.getPosition(B - AutoGeneratedSinkOption.begin()), *B));
        }
        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_m::InputLanguages_[] = {"objective-c", 0};

class llvm_gcc_m_pch : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_m_pch";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_m_pch is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "gch";

        cmd = "llvm-gcc";
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "objective-c-header"));

        if ((!OutputFilename.empty())
             && (InputFilenames.size() > 1)
             && ((AutoGeneratedSwitch_S)
             || (AutoGeneratedSwitch_c))) {
            throw std::runtime_error("cannot specify -o with -c or -S with multiple files");
        }
        if (AutoGeneratedSwitch_E) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_E.getPosition(), "-E"));
            stop_compilation = true;
            output_suffix = "mi";
        }
        if ((AutoGeneratedSwitch_E)
             && (OutputFilename.empty())) {
            no_out_file = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_S) {
            output_suffix = "ll";
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_fsyntax_dash_only) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fsyntax_dash_only.getPosition(), "-fsyntax-only"));
            no_out_file = true;
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_S.getPosition(), "-S"));
            vec.push_back(std::make_pair(AutoGeneratedSwitch_emit_dash_llvm.getPosition(), "-emit-llvm"));
        }
        if (! ((AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm)
             || (AutoGeneratedSwitch_fsyntax_dash_only))) {
            vec.push_back(std::make_pair(65536, "-c"));
            vec.push_back(std::make_pair(65536, "-emit-llvm"));
        }
        if (!AutoGeneratedList_Xpreprocessor.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xpreprocessor.begin(),
            E = AutoGeneratedList_Xpreprocessor.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xpreprocessor.getPosition(B - AutoGeneratedList_Xpreprocessor.begin());
                vec.push_back(std::make_pair(pos, "-Xpreprocessor"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_include.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_include.begin(),
            E = AutoGeneratedList_include.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_include.getPosition(B - AutoGeneratedList_include.begin());
                vec.push_back(std::make_pair(pos, "-include"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_iquote.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_iquote.begin(),
            E = AutoGeneratedList_iquote.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_iquote.getPosition(B - AutoGeneratedList_iquote.begin());
                vec.push_back(std::make_pair(pos, "-iquote"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!(SaveTemps == SaveTempsEnum::Unset)) {
            vec.push_back(std::make_pair(65536, "-save-temps"));
        }
        if (!AutoGeneratedList_I.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_I.begin(),
            E = AutoGeneratedList_I.end(); B != E;) {
                unsigned pos = AutoGeneratedList_I.getPosition(B - AutoGeneratedList_I.begin());
                vec.push_back(std::make_pair(pos, "-I" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_D.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_D.begin(),
            E = AutoGeneratedList_D.end(); B != E;) {
                unsigned pos = AutoGeneratedList_D.getPosition(B - AutoGeneratedList_D.begin());
                vec.push_back(std::make_pair(pos, "-D" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_march.getPosition(), "-march=" + AutoGeneratedParameter_march));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mtune=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_m.begin(),
            E = AutoGeneratedList_m.end(); B != E;) {
                unsigned pos = AutoGeneratedList_m.getPosition(B - AutoGeneratedList_m.begin());
                vec.push_back(std::make_pair(pos, "-m" + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_mfix_dash_and_dash_continue) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mfix_dash_and_dash_continue.getPosition(), "-mfix-and-continue"));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fPIC.getPosition(), "-fPIC"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mdynamic_dash_no_dash_pic.getPosition(), "-mdynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_MF.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), "-MF"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), AutoGeneratedParameter_MF));
        }
        if (!AutoGeneratedList_MT.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_MT.begin(),
            E = AutoGeneratedList_MT.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_MT.getPosition(B - AutoGeneratedList_MT.begin());
                vec.push_back(std::make_pair(pos, "-MT"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        if (!AutoGeneratedSinkOption.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedSinkOption.begin(), E = AutoGeneratedSinkOption.end(); B != E; ++B)
                vec.push_back(std::make_pair(AutoGeneratedSinkOption.getPosition(B - AutoGeneratedSinkOption.begin()), *B));
        }
        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_m_pch::InputLanguages_[] = {"objective-c-header", 0};

class llvm_gcc_mxx : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_mxx";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_mxx is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "bc";

        cmd = "llvm-gcc";
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "objective-c++"));

        if ((!OutputFilename.empty())
             && (InputFilenames.size() > 1)
             && ((AutoGeneratedSwitch_S)
             || (AutoGeneratedSwitch_c))) {
            throw std::runtime_error("cannot specify -o with -c or -S with multiple files");
        }
        if (AutoGeneratedSwitch_E) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_E.getPosition(), "-E"));
            stop_compilation = true;
            output_suffix = "mi";
        }
        if ((AutoGeneratedSwitch_E)
             && (OutputFilename.empty())) {
            no_out_file = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_S) {
            output_suffix = "ll";
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_fsyntax_dash_only) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fsyntax_dash_only.getPosition(), "-fsyntax-only"));
            no_out_file = true;
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_S.getPosition(), "-S"));
            vec.push_back(std::make_pair(AutoGeneratedSwitch_emit_dash_llvm.getPosition(), "-emit-llvm"));
        }
        if (! ((AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm)
             || (AutoGeneratedSwitch_fsyntax_dash_only))) {
            vec.push_back(std::make_pair(65536, "-c"));
            vec.push_back(std::make_pair(65536, "-emit-llvm"));
        }
        if (!AutoGeneratedList_Xpreprocessor.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xpreprocessor.begin(),
            E = AutoGeneratedList_Xpreprocessor.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xpreprocessor.getPosition(B - AutoGeneratedList_Xpreprocessor.begin());
                vec.push_back(std::make_pair(pos, "-Xpreprocessor"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_include.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_include.begin(),
            E = AutoGeneratedList_include.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_include.getPosition(B - AutoGeneratedList_include.begin());
                vec.push_back(std::make_pair(pos, "-include"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_iquote.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_iquote.begin(),
            E = AutoGeneratedList_iquote.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_iquote.getPosition(B - AutoGeneratedList_iquote.begin());
                vec.push_back(std::make_pair(pos, "-iquote"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!(SaveTemps == SaveTempsEnum::Unset)) {
            vec.push_back(std::make_pair(65536, "-save-temps"));
        }
        if (!AutoGeneratedList_I.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_I.begin(),
            E = AutoGeneratedList_I.end(); B != E;) {
                unsigned pos = AutoGeneratedList_I.getPosition(B - AutoGeneratedList_I.begin());
                vec.push_back(std::make_pair(pos, "-I" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_D.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_D.begin(),
            E = AutoGeneratedList_D.end(); B != E;) {
                unsigned pos = AutoGeneratedList_D.getPosition(B - AutoGeneratedList_D.begin());
                vec.push_back(std::make_pair(pos, "-D" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_march.getPosition(), "-march=" + AutoGeneratedParameter_march));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mtune=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_m.begin(),
            E = AutoGeneratedList_m.end(); B != E;) {
                unsigned pos = AutoGeneratedList_m.getPosition(B - AutoGeneratedList_m.begin());
                vec.push_back(std::make_pair(pos, "-m" + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_mfix_dash_and_dash_continue) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mfix_dash_and_dash_continue.getPosition(), "-mfix-and-continue"));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fPIC.getPosition(), "-fPIC"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mdynamic_dash_no_dash_pic.getPosition(), "-mdynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_MF.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), "-MF"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), AutoGeneratedParameter_MF));
        }
        if (!AutoGeneratedList_MT.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_MT.begin(),
            E = AutoGeneratedList_MT.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_MT.getPosition(B - AutoGeneratedList_MT.begin());
                vec.push_back(std::make_pair(pos, "-MT"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        if (!AutoGeneratedSinkOption.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedSinkOption.begin(), E = AutoGeneratedSinkOption.end(); B != E; ++B)
                vec.push_back(std::make_pair(AutoGeneratedSinkOption.getPosition(B - AutoGeneratedSinkOption.begin()), *B));
        }
        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_mxx::InputLanguages_[] = {"objective-c++", 0};

class llvm_gcc_mxx_pch : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "llvm_gcc_mxx_pch";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("llvm_gcc_mxx_pch is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "gch";

        cmd = "llvm-gcc";
        vec.push_back(std::make_pair(0, "-x"));
        vec.push_back(std::make_pair(0, "objective-c++-header"));

        if ((!OutputFilename.empty())
             && (InputFilenames.size() > 1)
             && ((AutoGeneratedSwitch_S)
             || (AutoGeneratedSwitch_c))) {
            throw std::runtime_error("cannot specify -o with -c or -S with multiple files");
        }
        if (AutoGeneratedSwitch_E) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_E.getPosition(), "-E"));
            stop_compilation = true;
            output_suffix = "mi";
        }
        if ((AutoGeneratedSwitch_E)
             && (OutputFilename.empty())) {
            no_out_file = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_S) {
            output_suffix = "ll";
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_emit_dash_llvm && AutoGeneratedSwitch_c) {
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_fsyntax_dash_only) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fsyntax_dash_only.getPosition(), "-fsyntax-only"));
            no_out_file = true;
            stop_compilation = true;
        }
        if (AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_S.getPosition(), "-S"));
            vec.push_back(std::make_pair(AutoGeneratedSwitch_emit_dash_llvm.getPosition(), "-emit-llvm"));
        }
        if (! ((AutoGeneratedSwitch_S && AutoGeneratedSwitch_emit_dash_llvm)
             || (AutoGeneratedSwitch_fsyntax_dash_only))) {
            vec.push_back(std::make_pair(65536, "-c"));
            vec.push_back(std::make_pair(65536, "-emit-llvm"));
        }
        if (!AutoGeneratedList_Xpreprocessor.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Xpreprocessor.begin(),
            E = AutoGeneratedList_Xpreprocessor.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_Xpreprocessor.getPosition(B - AutoGeneratedList_Xpreprocessor.begin());
                vec.push_back(std::make_pair(pos, "-Xpreprocessor"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_include.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_include.begin(),
            E = AutoGeneratedList_include.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_include.getPosition(B - AutoGeneratedList_include.begin());
                vec.push_back(std::make_pair(pos, "-include"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_iquote.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_iquote.begin(),
            E = AutoGeneratedList_iquote.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_iquote.getPosition(B - AutoGeneratedList_iquote.begin());
                vec.push_back(std::make_pair(pos, "-iquote"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }
        if (!(SaveTemps == SaveTempsEnum::Unset)) {
            vec.push_back(std::make_pair(65536, "-save-temps"));
        }
        if (!AutoGeneratedList_I.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_I.begin(),
            E = AutoGeneratedList_I.end(); B != E;) {
                unsigned pos = AutoGeneratedList_I.getPosition(B - AutoGeneratedList_I.begin());
                vec.push_back(std::make_pair(pos, "-I" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_F.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_F.begin(),
            E = AutoGeneratedList_F.end(); B != E;) {
                unsigned pos = AutoGeneratedList_F.getPosition(B - AutoGeneratedList_F.begin());
                vec.push_back(std::make_pair(pos, "-F" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedList_D.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_D.begin(),
            E = AutoGeneratedList_D.end(); B != E;) {
                unsigned pos = AutoGeneratedList_D.getPosition(B - AutoGeneratedList_D.begin());
                vec.push_back(std::make_pair(pos, "-D" + *B));
                ++B;
            }
        }
        if (!AutoGeneratedParameter_arch.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), "-arch"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_arch.getPosition(), AutoGeneratedParameter_arch));
        }
        if (!AutoGeneratedParameter_march.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_march.getPosition(), "-march=" + AutoGeneratedParameter_march));
        }
        if (!AutoGeneratedParameter_mtune.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mtune.getPosition(), "-mtune=" + AutoGeneratedParameter_mtune));
        }
        if (!AutoGeneratedParameter_mcpu.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_mcpu.getPosition(), "-mcpu=" + AutoGeneratedParameter_mcpu));
        }
        if (!AutoGeneratedList_m.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_m.begin(),
            E = AutoGeneratedList_m.end(); B != E;) {
                unsigned pos = AutoGeneratedList_m.getPosition(B - AutoGeneratedList_m.begin());
                vec.push_back(std::make_pair(pos, "-m" + *B));
                ++B;
            }
        }
        if (AutoGeneratedSwitch_mfix_dash_and_dash_continue) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mfix_dash_and_dash_continue.getPosition(), "-mfix-and-continue"));
        }
        if (AutoGeneratedSwitch_m32) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m32.getPosition(), "-m32"));
        }
        if (AutoGeneratedSwitch_m64) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_m64.getPosition(), "-m64"));
        }
        if (AutoGeneratedSwitch_O0) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O0.getPosition(), "-O0"));
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }
        if (AutoGeneratedSwitch_fPIC) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_fPIC.getPosition(), "-fPIC"));
        }
        if (AutoGeneratedSwitch_mdynamic_dash_no_dash_pic) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_mdynamic_dash_no_dash_pic.getPosition(), "-mdynamic-no-pic"));
        }
        if (!AutoGeneratedParameter_MF.empty()) {
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), "-MF"));
            vec.push_back(std::make_pair(AutoGeneratedParameter_MF.getPosition(), AutoGeneratedParameter_MF));
        }
        if (!AutoGeneratedList_MT.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_MT.begin(),
            E = AutoGeneratedList_MT.end() ; B != E;) {
                unsigned pos = AutoGeneratedList_MT.getPosition(B - AutoGeneratedList_MT.begin());
                vec.push_back(std::make_pair(pos, "-MT"));
                vec.push_back(std::make_pair(pos, *B));
                ++B;
            }
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        if (!AutoGeneratedSinkOption.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedSinkOption.begin(), E = AutoGeneratedSinkOption.end(); B != E; ++B)
                vec.push_back(std::make_pair(AutoGeneratedSinkOption.getPosition(B - AutoGeneratedSinkOption.begin()), *B));
        }
        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* llvm_gcc_mxx_pch::InputLanguages_[] = {"objective-c++-header", 0};

class opt : public Tool {
private:
    static const char* InputLanguages_[];

public:
    const char* Name() const {
        return "opt";
    }

    const char** InputLanguages() const {
        return InputLanguages_;
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    bool IsJoin() const {
        return false;
    }

    bool WorksOnEmpty() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        throw std::runtime_error("opt is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        bool HasChildren,
        const llvm::sys::Path& TempDir,
        const InputLanguagesSet& InLangs,
        const LanguageMap& LangMap) const
    {
        std::string cmd;
        std::string out_file;
        std::vector<std::pair<unsigned, std::string> > vec;
        bool stop_compilation = !HasChildren;
        bool no_out_file = false;
        const char* output_suffix = "bc";

        cmd = "opt";
        vec.push_back(std::make_pair(0, "-f"));

        if (!AutoGeneratedList_Wo_comma_.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedList_Wo_comma_.begin(), 
                 E = AutoGeneratedList_Wo_comma_.end(); B != E; ++B)
            {
                unsigned pos = AutoGeneratedList_Wo_comma_.getPosition(B - AutoGeneratedList_Wo_comma_.begin());
                vec.push_back(std::make_pair(pos, *B));
            }
        }
        if (AutoGeneratedSwitch_O1) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O1.getPosition(), "-O1"));
        }
        if (AutoGeneratedSwitch_O2) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O2.getPosition(), "-O2"));
        }
        if (AutoGeneratedSwitch_O3) {
            vec.push_back(std::make_pair(AutoGeneratedSwitch_O3.getPosition(), "-O3"));
        }

        vec.push_back(std::make_pair(InputFilenames.getPosition(0), inFile.str()));
        if (!no_out_file) {
            vec.push_back(std::make_pair(65536, "-o"));
            out_file = this->OutFilename(inFile,
                TempDir, stop_compilation, output_suffix).str();

            vec.push_back(std::make_pair(65536, out_file));
        }

        return Action(cmd, this->SortArgs(vec), stop_compilation, out_file);
    }

};
const char* opt::InputLanguages_[] = {"llvm-bitcode", 0};

class Edge15: public Edge {
public:
    Edge15() : Edge("llvm_as") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitch_emit_dash_llvm) {
            ret += 2;
        }
        return ret;
    }

};

class Edge16: public Edge {
public:
    Edge16() : Edge("opt") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitch_opt) {
            ret += 2;
        }
        return ret;
    }

};

class Edge17: public Edge {
public:
    Edge17() : Edge("opt") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitch_opt) {
            ret += 2;
        }
        return ret;
    }

};

class Edge18: public Edge {
public:
    Edge18() : Edge("opt") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitch_opt) {
            ret += 2;
        }
        return ret;
    }

};

class Edge19: public Edge {
public:
    Edge19() : Edge("opt") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitch_opt) {
            ret += 2;
        }
        return ret;
    }

};

class Edge20: public Edge {
public:
    Edge20() : Edge("opt") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitch_opt) {
            ret += 2;
        }
        return ret;
    }

};

class Edge24: public Edge {
public:
    Edge24() : Edge("llvm_gcc_cpp_linker") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if ((InLangs.count("c++") != 0)
             || (InLangs.count("objective-c++") != 0)) {
            ret += 2;
        }
        if ((AutoGeneratedParameter_linker == "g++")
             || (AutoGeneratedParameter_linker == "c++")) {
            ret += 2;
        }
        return ret;
    }

};

class Edge26: public Edge {
public:
    Edge26() : Edge("llvm_gcc_cpp_linker") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if ((InLangs.count("c++") != 0)
             || (InLangs.count("objective-c++") != 0)) {
            ret += 2;
        }
        if ((AutoGeneratedParameter_linker == "g++")
             || (AutoGeneratedParameter_linker == "c++")) {
            ret += 2;
        }
        return ret;
    }

};

void PopulateCompilationGraphLocal(CompilationGraph& G) {
    G.insertNode(new llc());
    G.insertNode(new llvm_as());
    G.insertNode(new llvm_gcc_assembler());
    G.insertNode(new llvm_gcc_c());
    G.insertNode(new llvm_gcc_c_pch());
    G.insertNode(new llvm_gcc_cpp());
    G.insertNode(new llvm_gcc_cpp_linker());
    G.insertNode(new llvm_gcc_cpp_pch());
    G.insertNode(new llvm_gcc_linker());
    G.insertNode(new llvm_gcc_m());
    G.insertNode(new llvm_gcc_m_pch());
    G.insertNode(new llvm_gcc_mxx());
    G.insertNode(new llvm_gcc_mxx_pch());
    G.insertNode(new opt());

    G.insertEdge("root", new SimpleEdge("llvm_gcc_c"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_assembler"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_cpp"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_m"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_mxx"));
    G.insertEdge("root", new SimpleEdge("llc"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_c_pch"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_cpp_pch"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_m_pch"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_mxx_pch"));
    G.insertEdge("llvm_gcc_c", new SimpleEdge("llc"));
    G.insertEdge("llvm_gcc_cpp", new SimpleEdge("llc"));
    G.insertEdge("llvm_gcc_m", new SimpleEdge("llc"));
    G.insertEdge("llvm_gcc_mxx", new SimpleEdge("llc"));
    G.insertEdge("llvm_as", new SimpleEdge("llc"));
    G.insertEdge("root", new Edge15());
    G.insertEdge("llvm_gcc_c", new Edge16());
    G.insertEdge("llvm_gcc_cpp", new Edge17());
    G.insertEdge("llvm_gcc_m", new Edge18());
    G.insertEdge("llvm_gcc_mxx", new Edge19());
    G.insertEdge("llvm_as", new Edge20());
    G.insertEdge("opt", new SimpleEdge("llc"));
    G.insertEdge("llc", new SimpleEdge("llvm_gcc_assembler"));
    G.insertEdge("llvm_gcc_assembler", new SimpleEdge("llvm_gcc_linker"));
    G.insertEdge("llvm_gcc_assembler", new Edge24());
    G.insertEdge("root", new SimpleEdge("llvm_gcc_linker"));
    G.insertEdge("root", new Edge26());
}

struct Plugin : public llvmc::BasePlugin {

    int Priority() const { return 0; }

    void PreprocessOptions() const
    { PreprocessOptionsLocal(); }

    void PopulateLanguageMap(LanguageMap& langMap) const
    { PopulateLanguageMapLocal(langMap); }

    void PopulateCompilationGraph(CompilationGraph& graph) const
    { PopulateCompilationGraphLocal(graph); }
};

static llvmc::RegisterPlugin<Plugin> RP;

} // End anonymous namespace.

namespace llvmc {
LLVMC_FORCE_LINKAGE_DECL(LLVMC_PLUGIN_NAME) {}
}
